'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _superagent = require('superagent');

var _superagent2 = _interopRequireDefault(_superagent);

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var http_methods = {
	get: 'get',
	post: 'post',
	call: 'post',
	create: 'post',
	put: 'put',
	update: 'put',
	patch: 'patch',
	delete: 'del'
};

var http_client = {};

var _iteratorNormalCompletion = true;
var _didIteratorError = false;
var _iteratorError = undefined;

try {
	var _loop = function _loop() {
		var method = _step.value;

		http_client[method] = function (destination, data, options) {
			var http_method = http_methods[method];

			if (!http_method) {
				throw new Error('Api method not found: ' + method);
			}

			var url = format_url(destination);

			return new _promise2.default(function (resolve, reject) {
				var request = _superagent2.default[http_method](url);

				if (data) {
					if (http_method === 'post') {
						request.send(data);
					} else {
						request.query(data);
					}
				}

				if (options && options.headers) {
					var _iteratorNormalCompletion2 = true;
					var _didIteratorError2 = false;
					var _iteratorError2 = undefined;

					try {
						for (var _iterator2 = (0, _getIterator3.default)((0, _keys2.default)(options.headers)), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
							var key = _step2.value;

							request.set(key, options.headers[key]);
						}
					} catch (err) {
						_didIteratorError2 = true;
						_iteratorError2 = err;
					} finally {
						try {
							if (!_iteratorNormalCompletion2 && _iterator2.return) {
								_iterator2.return();
							}
						} finally {
							if (_didIteratorError2) {
								throw _iteratorError2;
							}
						}
					}
				}

				if (options && options.locale) {
					request.set('accept-language', locale);
				}

				request.end(function (error, response) {
					if (!error && response) {
						error = response.error;
					}

					if (error) {
						// superagent would have already output the error to console
						// console.error(error.stack)

						console.log('[http client] (http request error)');

						if (response) {
							error.code = response.status;

							var content_type = response.get('content-type').split(';')[0].trim();

							if (content_type === 'text/plain') {
								error.message = response.text;
							} else if (content_type === 'text/html') {
								error.html = response.text;
							}
						}

						return reject(error);
					}

					resolve(response.body);
				});
			});
		};
	};

	for (var _iterator = (0, _getIterator3.default)((0, _keys2.default)(http_methods)), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
		_loop();
	}
} catch (err) {
	_didIteratorError = true;
	_iteratorError = err;
} finally {
	try {
		if (!_iteratorNormalCompletion && _iterator.return) {
			_iterator.return();
		}
	} finally {
		if (_didIteratorError) {
			throw _iteratorError;
		}
	}
}

function format_url(destination) {
	if ((0, _helpers.is_object)(destination)) {
		// Prepend host and port of the API server to the path.
		return 'http://' + destination.host + ':' + destination.port + destination.path;
	}

	// Prepend prefix to relative URL, to proxy to API server.
	return destination;
}

exports.default = http_client;

// import http        from 'http'
// import querystring from 'querystring'

// Promise.promisifyAll(http)

// export function get(options)
// {
// 	return new Promise((resolve, reject) =>
// 	{
// 		const http_request = http.request
// 		({
// 			host: configuration.authentication_service.http.host,
// 			port: configuration.authentication_service.http.port,
// 			path: options.parameters ? `${options.path}?${querystring.stringify(options.parameters)}` : options.path
// 		},
// 		response =>
// 		{
// 			let response_data = ''

// 			response.setEncoding('utf8')

// 			if ()

// 			response.on('data', chunk =>
// 			{
// 				response_data += chunk
// 			})

// 			response.on('end', () =>
// 			{
// 				resolve(response)
// 			})
// 		})

// 		http_request.on('error', error => reject(error))

// 		// // write data to request body
// 		// http_request.write(postData)

// 		http_request.end()
// 	})
// }

module.exports = exports['default'];
//# sourceMappingURL=http.js.map