'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.default = function (from, to) {
	if (!(0, _helpers.exists)(to)) {
		to = from;
		from = undefined;
	}

	var proxy = _httpProxy2.default.createProxyServer({});

	function proxy_middleware(to) {
		return function () {
			var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(ctx) {
				var promise;
				return _regenerator2.default.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								promise = new _promise2.default(function (resolve, reject) {
									ctx.res.on('close', function () {
										reject(new Error('Http response closed while proxying ' + ctx.url + ' to ' + to));
									});

									ctx.res.on('finish', function () {
										resolve();
									});

									// promisify(proxy.web, proxy) won't work here,
									// because the last parameter is not a "callback",
									// it's just an error handler.
									// https://github.com/nodejitsu/node-http-proxy/issues/951
									proxy.web(ctx.req, ctx.res, { target: to }, function (error) {
										// usually errors with "Parse error" which is useless

										// error.proxy_error = true
										// error.proxy_to = to

										console.error('Proxying failed');
										reject(error);

										// response.writeHead(502)
										// response.end("There was an error proxying your request")
									});
								});
								_context.next = 3;
								return promise;

							case 3:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, this);
			}));

			return function (_x) {
				return _ref.apply(this, arguments);
			};
		}();
	}

	var result = { proxy: proxy };

	if (from) {
		result.middleware = (0, _koaMount2.default)(from, proxy_middleware(to));
	} else {
		result.middleware = proxy_middleware(to);
	}

	return result;
};

var _httpProxy = require('http-proxy');

var _httpProxy2 = _interopRequireDefault(_httpProxy);

var _koaMount = require('koa-mount');

var _koaMount2 = _interopRequireDefault(_koaMount);

var _helpers = require('../helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = exports['default'];
//# sourceMappingURL=proxy.js.map